/* ############################# MPC License ############################## */
/* # Wed Nov 19 15:19:19 CET 2008                                         # */
/* # Copyright or (C) or Copr. Commissariat a l'Energie Atomique          # */
/* #                                                                      # */
/* # IDDN.FR.001.230040.000.S.P.2007.000.10000                            # */
/* # This file is part of the MPC Runtime.                                # */
/* #                                                                      # */
/* # This software is governed by the CeCILL-C license under French law   # */
/* # and abiding by the rules of distribution of free software.  You can  # */
/* # use, modify and/ or redistribute the software under the terms of     # */
/* # the CeCILL-C license as circulated by CEA, CNRS and INRIA at the     # */
/* # following URL "http://www.cecill.info".                              # */
/* #                                                                      # */
/* # The fact that you are presently reading this means that you have     # */
/* # had knowledge of the CeCILL-C license and that you accept its        # */
/* # terms.                                                               # */
/* #                                                                      # */
/* # Authors:                                                             # */
/* #   - PERACHE Marc marc.perache@cea.fr                                 # */
/* #                                                                      # */
/* ######################################################################## */
#ifndef __SCTK__THREAD_DBG__
#define __SCTK__THREAD_DBG__

#ifdef __cplusplus
extern "C"
{
#endif

#include "sctk_config.h"
#include "sctk_thread.h"

#ifndef NO_INTERNAL_ASSERT
#define SCTK_USE_THREAD_DEBUG
#endif

#if defined(SCTK_USE_THREAD_DEBUG)
  void sctk_thread_add (sctk_thread_data_t * item);
  void sctk_thread_remove (sctk_thread_data_t * item);
  void sctk_thread_print_stack_out (void);
  void sctk_thread_debug_printf (const char *format, ...);
  void sctk_thread_current (void);

  void sctk_thread_goto (int j);
  void sctk_thread_enable_debug (void);
  void sctk_thread_disable_debug (void);
  void sctk_thread_list (void);
  void sctk_thread_list_task (int j);
  void sctk_thread_print_stack_in (int j);
  void sctk_thread_print_stack_task (int j);
  void sctk_thread_print_stack_out (void);
#else
#define sctk_thread_add(a) (void)(0)
#define sctk_thread_remove(a) (void)(0)
#endif

#ifdef __cplusplus
}				/* end of extern "C" */
#endif
#endif
