/* ############################# MPC License ############################## */
/* # Wed Nov 19 15:19:19 CET 2008                                         # */
/* # Copyright or (C) or Copr. Commissariat a l'Energie Atomique          # */
/* #                                                                      # */
/* # IDDN.FR.001.230040.000.S.P.2007.000.10000                            # */
/* # This file is part of the MPC Runtime.                                # */
/* #                                                                      # */
/* # This software is governed by the CeCILL-C license under French law   # */
/* # and abiding by the rules of distribution of free software.  You can  # */
/* # use, modify and/ or redistribute the software under the terms of     # */
/* # the CeCILL-C license as circulated by CEA, CNRS and INRIA at the     # */
/* # following URL "http://www.cecill.info".                              # */
/* #                                                                      # */
/* # The fact that you are presently reading this means that you have     # */
/* # had knowledge of the CeCILL-C license and that you accept its        # */
/* # terms.                                                               # */
/* #                                                                      # */
/* # Authors:                                                             # */
/* #   - PERACHE Marc marc.perache@cea.fr                                 # */
/* #                                                                      # */
/* ######################################################################## */
#include <stdio.h>
#include <mpc.h>
#include <assert.h>

#define MPC_INTEGER_VAL(sa,a) printf("       INTEGER %s\n       PARAMETER (%s=%d)\n",sa,sa,(int)a)

#define MPC_INTEGER_8_VAL(sa,a) printf("       INTEGER*8 %s\n       PARAMETER (%s=%ld)\n",sa,sa,(long)a)

#define MPC_POINTER_CONV_VAL(sa,a) printf("       EXTERNAL %s\n",sa)

int
main (int argc, char **argv)
{
  assert (argc == 1);
  assert (argv[1] == NULL);

  printf
    ("\
! ############################# MPC License ############################## \n\
! # Wed Nov 19 15:19:19 CET 2008                                         # \n\
! # Copyright or (C) or Copr. Commissariat a l'Energie Atomique          # \n\
! #                                                                      # \n\
! # IDDN.FR.001.230040.000.S.P.2007.000.10000                            # \n\
! # This file is part of the MPC Runtime.                                # \n\
! #                                                                      # \n\
! # This software is governed by the CeCILL-C license under French law   # \n\
! # and abiding by the rules of distribution of free software.  You can  # \n\
! # use, modify and/ or redistribute the software under the terms of     # \n\
! # the CeCILL-C license as circulated by CEA, CNRS and INRIA at the     # \n\
! # following URL "http://www.cecill.info".                              # \n\
! #                                                                      # \n\
! # The fact that you are presently reading this means that you have     # \n\
! # had knowledge of the CeCILL-C license and that you accept its        # \n\
! # terms.                                                               # \n\
! #                                                                      # \n\
! # Authors:                                                             # \n\
! #   - PERACHE Marc marc.perache@cea.fr                                 # \n\
! #                                                                      # \n\
! ######################################################################## \n");

/*   MPC_INTEGER_VAL("MPC_",MPC_); */
  MPC_INTEGER_VAL ("MPC_COMM_WORLD", MPC_COMM_WORLD);
  MPC_INTEGER_VAL ("MPC_SUCCESS", MPC_SUCCESS);
  MPC_INTEGER_VAL ("MPC_ERR_BUFFER", MPC_ERR_BUFFER);
  MPC_INTEGER_VAL ("MPC_ERR_COUNT", MPC_ERR_COUNT);
  MPC_INTEGER_VAL ("MPC_ERR_TYPE", MPC_ERR_TYPE);
  MPC_INTEGER_VAL ("MPC_ERR_TAG", MPC_ERR_TAG);
  MPC_INTEGER_VAL ("MPC_ERR_COMM", MPC_ERR_COMM);
  MPC_INTEGER_VAL ("MPC_ERR_RANK", MPC_ERR_RANK);
  MPC_INTEGER_VAL ("MPC_ERR_ROOT", MPC_ERR_ROOT);
  MPC_INTEGER_VAL ("MPC_ERR_TRUNCATE", MPC_ERR_TRUNCATE);
  MPC_INTEGER_VAL ("MPC_ERR_GROUP", MPC_ERR_GROUP);
  MPC_INTEGER_VAL ("MPC_ERR_OP", MPC_ERR_OP);
  MPC_INTEGER_VAL ("MPC_ERR_REQUEST", MPC_ERR_REQUEST);
  MPC_INTEGER_VAL ("MPC_ERR_TOPOLOGY", MPC_ERR_TOPOLOGY);
  MPC_INTEGER_VAL ("MPC_ERR_DIMS", MPC_ERR_DIMS);
  MPC_INTEGER_VAL ("MPC_ERR_ARG", MPC_ERR_ARG);
  MPC_INTEGER_VAL ("MPC_ERR_OTHER", MPC_ERR_OTHER);
  MPC_INTEGER_VAL ("MPC_ERR_UNKNOWN", MPC_ERR_UNKNOWN);
  MPC_INTEGER_VAL ("MPC_ERR_INTERN", MPC_ERR_INTERN);
  MPC_INTEGER_VAL ("MPC_ERR_IN_STATUS", MPC_ERR_IN_STATUS);
  MPC_INTEGER_VAL ("MPC_ERR_PENDING", MPC_ERR_PENDING);
  MPC_INTEGER_VAL ("MPC_NOT_IMPLEMENTED", MPC_NOT_IMPLEMENTED);
  MPC_INTEGER_VAL ("MPC_ERR_LASTCODE", MPC_ERR_LASTCODE);
  MPC_INTEGER_VAL ("MPC_ANY_TAG", MPC_ANY_TAG);
  MPC_INTEGER_VAL ("MPC_ANY_SOURCE", MPC_ANY_SOURCE);
  MPC_INTEGER_VAL ("MPC_PROC_NULL", MPC_PROC_NULL);
  MPC_INTEGER_VAL ("MPC_COMM_NULL", MPC_COMM_NULL);
  MPC_INTEGER_VAL ("MPC_MAX_PROCESSOR_NAME", MPC_MAX_PROCESSOR_NAME);

  if (sizeof (long) == 4)
    {
      MPC_INTEGER_VAL ("MPC_DATATYPE_NULL", MPC_DATATYPE_NULL);
      MPC_INTEGER_VAL ("MPC_CHAR", MPC_CHAR);
      MPC_INTEGER_VAL ("MPC_LOGICAL", MPC_LOGICAL);
      MPC_INTEGER_VAL ("MPC_BYTE", MPC_BYTE);
      MPC_INTEGER_VAL ("MPC_SHORT", MPC_SHORT);
      MPC_INTEGER_VAL ("MPC_INT", MPC_INT);
      MPC_INTEGER_VAL ("MPC_INTEGER", MPC_INT);
      MPC_INTEGER_VAL ("MPC_2INT", MPC_2INT);
      MPC_INTEGER_VAL ("MPC_2INTEGER", MPC_2INT);
      MPC_INTEGER_VAL ("MPC_LONG", MPC_LONG);
      MPC_INTEGER_VAL ("MPC_FLOAT", MPC_FLOAT);
      MPC_INTEGER_VAL ("MPC_DOUBLE", MPC_DOUBLE);
      MPC_INTEGER_VAL ("MPC_REAL", MPC_FLOAT);
      MPC_INTEGER_VAL ("MPC_DOUBLE_PRECISION", MPC_DOUBLE);
      MPC_INTEGER_VAL ("MPC_REAL8", MPC_DOUBLE);
      MPC_INTEGER_VAL ("MPC_COMPLEX", MPC_COMPLEX);
      MPC_INTEGER_VAL ("MPC_2REAL", MPC_2FLOAT);
      MPC_INTEGER_VAL ("MPC_2DOUBLE_PRECISION", MPC_2DOUBLE_PRECISION);
    }
  else
    {
      MPC_INTEGER_8_VAL ("MPC_DATATYPE_NULL", MPC_DATATYPE_NULL);
      MPC_INTEGER_8_VAL ("MPC_CHAR", MPC_CHAR);
      MPC_INTEGER_8_VAL ("MPC_LOGICAL", MPC_LOGICAL);
      MPC_INTEGER_8_VAL ("MPC_BYTE", MPC_BYTE);
      MPC_INTEGER_8_VAL ("MPC_SHORT", MPC_SHORT);
      MPC_INTEGER_8_VAL ("MPC_INT", MPC_INT);
      MPC_INTEGER_8_VAL ("MPC_INTEGER", MPC_INT);
      MPC_INTEGER_8_VAL ("MPC_2INT", MPC_2INT);
      MPC_INTEGER_8_VAL ("MPC_2INTEGER", MPC_2INT);
      MPC_INTEGER_8_VAL ("MPC_LONG", MPC_LONG);
      MPC_INTEGER_8_VAL ("MPC_FLOAT", MPC_FLOAT);
      MPC_INTEGER_8_VAL ("MPC_DOUBLE", MPC_DOUBLE);
      MPC_INTEGER_8_VAL ("MPC_REAL", MPC_FLOAT);
      MPC_INTEGER_8_VAL ("MPC_DOUBLE_PRECISION", MPC_DOUBLE);
      MPC_INTEGER_8_VAL ("MPC_COMPLEX", MPC_COMPLEX);
      MPC_INTEGER_8_VAL ("MPC_2REAL", MPC_2FLOAT);
      MPC_INTEGER_8_VAL ("MPC_2DOUBLE_PRECISION", MPC_2DOUBLE_PRECISION);
    }

  printf ("       INTEGER MPC_BOTTOM\n");

  MPC_POINTER_CONV_VAL ("MPC_SUM", MPC_SUM);
  MPC_POINTER_CONV_VAL ("MPC_MAX", MPC_MAX);
  MPC_POINTER_CONV_VAL ("MPC_MIN", MPC_MIN);
  MPC_POINTER_CONV_VAL ("MPC_PROD", MPC_PROD);
  MPC_POINTER_CONV_VAL ("MPC_LAND", MPC_LAND);
  MPC_POINTER_CONV_VAL ("MPC_BAND", MPC_BAND);
  MPC_POINTER_CONV_VAL ("MPC_LOR", MPC_LOR);
  MPC_POINTER_CONV_VAL ("MPC_BOR", MPC_BOR);
  MPC_POINTER_CONV_VAL ("MPC_LXOR", MPC_LXOR);
  MPC_POINTER_CONV_VAL ("MPC_BXOR", MPC_BXOR);
  MPC_POINTER_CONV_VAL ("MPC_MINLOC", MPC_MINLOC);
  MPC_POINTER_CONV_VAL ("MPC_MAXLOC", MPC_MAXLOC);

  /*Architecture dependent part */
  MPC_INTEGER_VAL ("MPC_STATUS_SIZE", (int) (sizeof (MPC_Status) / 4));
  assert (sizeof (MPC_Status) % 4 == 0);
  MPC_INTEGER_VAL ("MPC_REQUEST_SIZE", (int) (sizeof (MPC_Request) / 4));
  assert (sizeof (MPC_Request) % 4 == 0);


  return 0;
}
